/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExtjsForm
{
    public interface IControlType
    {
        string Name { get; }
        /// <summary>
        /// Gets a value indicating whether [require entire row].
        /// </summary>
        /// <value><c>true</c> if [require entire row]; otherwise, <c>false</c>.</value>
        bool EntireRow { get;  }

        /// <summary>
        /// Gets a value indicating whether [file upload].
        /// </summary>
        /// <value><c>true</c> if [file upload]; otherwise, <c>false</c>.</value>
        bool FileUpload { get; }
        string Render(IColumn column);
    }
}

