/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExtjsForm
{
    /// <summary>
    /// 
    /// </summary>
    public interface IControlTypeFactory
    {
        /// <summary>
        /// Registers the type of the control.
        /// </summary>
        /// <param name="controlType">Type of the control.</param>
        void RegisterControlType(string name, Type controlType);
        /// <summary>
        /// Resolves the type of the control.
        /// </summary>
        /// <param name="columnType">Type of the column.</param>
        /// <returns></returns>
        IControlType ResolveControl(string controlName);

        /// <summary>
        /// Resolves the type of all column control.
        /// </summary>
        /// <returns></returns>
        IDictionary<string, Type> ResolveAllControlType();
    }
}

