/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;

namespace ExtjsForm
{
    public interface ISchema : IColumnContainer
    {
        string Name
        {
            get;
            set;
        }
        string Title
        {
            get;
            set;
        }


        string UserName
        {
            get;
            set;
        }
        /// <summary>
        /// Gets or sets the query URL.
        /// </summary>
        /// <value>The query URL.</value>
        string QueryUrl
        { get; set; }

        /// <summary>
        /// Gets or sets the details URL.
        /// </summary>
        /// <value>The details URL.</value>
        string DetailsUrl
        {
            get;
            set;
        }
        /// <summary>
        /// Gets or sets the submit URL.
        /// </summary>
        /// <value>The submit URL.</value>
        string SubmitUrl
        {
            get;
            set;
        }
        /// <summary>
        /// Gets or sets the delete URL.
        /// </summary>
        /// <value>The delete URL.</value>
        string DeleteUrl
        { get; set; }
        /// <summary>
        /// Gets or sets the grid base.
        /// </summary>
        /// <value>The grid base.</value>
        string GridType
        {
            get;
            set;
        }
        /// <summary>
        /// Gets or sets the form base.
        /// </summary>
        /// <value>The form base.</value>
        string FormType
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the child schames.
        /// </summary>
        /// <value>The child schames.</value>
        IEnumerable<SchemaRefrence> SchemaRefrences { get; set; }

        /// <summary>
        /// Gets or sets the attributes.
        /// </summary>
        /// <value>The attributes.</value>
        NameValueCollection GridAttributes { get; set; }

        /// <summary>
        /// Gets or sets the form attributes.
        /// </summary>
        /// <value>The form attributes.</value>
        NameValueCollection FormAttributes { get; set; }
    }
}

