/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExtjsForm
{
    public class Column : IColumn
    {
        public Column()
        {
            this.ListAttributes = new System.Collections.Specialized.NameValueCollection();
            this.DetailAttributes = new System.Collections.Specialized.NameValueCollection();
            this.Modifiable = true;
            this.AllowNull = true;
        }
        #region IColumn Members

        public string Name
        {
            get;
            set;
        }

        public string Label
        {
            get;
            set;
        }

        public int Length
        {
            get;
            set;
        }

        public bool AllowNull
        {
            get;
            set;
        }

        public string Description
        {
            get;
            set;
        }

        public string DefaultValue
        {
            get;
            set;
        }

        public string Items
        {
            get;
            set;
        }

        public IControlType Control
        {
            get;
            set;
        }

        public int Order
        {
            get;
            set;
        }

        public bool EntireRow
        {
            get;
            set;
        }

        #endregion

        #region IColumn Members

        public bool Queryable
        {
            get;
            set;
        }

        #endregion

        #region IColumn Members
        /// <summary>
        /// Gets or sets the data index in list.
        /// </summary>
        /// <value>The data index in list.</value>
        public string DataIndexInList
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the data index in detail.
        /// </summary>
        /// <value>The data index in detail.</value>
        public string DataIndexInDetail
        {
            get;
            set;
        }

        #endregion

        #region IColumn Members


        public System.Collections.Specialized.NameValueCollection ListAttributes
        {
            get;
            set;
        }

        public System.Collections.Specialized.NameValueCollection DetailAttributes
        {
            get;
            set;
        }

        #endregion

        #region IColumn Members


        public bool Modifiable
        {
            get;
            set;
        }

        #endregion

        #region IColumn Members
        IList<IColumn> columns = new List<IColumn>();

        public IColumn[] Columns
        {
            get { return this.columns.ToArray(); }
        }
        public void AddColumn(IColumn column)
        {
            this.columns.Add(column);
        }

        #endregion
    }
}

