/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;

using Everest.Library;
using Everest.Library.Mvc;
using Everest.Library.Extjs.Tree;
using ExtjsForm;

namespace ExtjsForm.Controllers
{
    public partial class FormController : ExtControllerBase
    {
        protected ITreeNodeProvider treeNodeProvider;
        protected IGeneratorFactory factory;
        public FormController()
        {
            treeNodeProvider = new XmlTreeNodeProvider("adminNavigate.config", new RoleChecker());
        }
        public FormController(ITreeNodeProvider treeNodeProvider, IGeneratorFactory factory)
        {
            this.treeNodeProvider = treeNodeProvider;
            this.factory = factory;
        }

        public virtual ActionResult Index()
        {
            return View();
        }

        public virtual ActionResult GetTreeNodes(string id)
        {
            JsonResult jsonResult = new JsonResult();
            jsonResult.Data = treeNodeProvider.GetChildNodes(id, Request.Form);
            return jsonResult;
        }

        public virtual string GetForm(string schema, string formType)
        {
            IFormGenerator generator = factory.GetGenerator(formType);
            return generator.Generate(schema, Request.Form);
        }
    }
}

