/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Principal;

using Everest.Library.Extjs.Tree;
namespace ExtjsForm.Controllers
{
    public class RoleChecker : ITreeNodeChecker
    {
        #region ITreeNodeChecker Members

        public bool IsVisible(TreeNode node)
        {
            IPrincipal user= System.Threading.Thread.CurrentPrincipal;
            if (node.Attributes.ContainsKey("roles"))
            {
                string[] roles = node.Attributes["roles"].ToString().Split(',');
                foreach (string role in roles)
                {
                    if (user.IsInRole(role))
                    {
                        return true;
                    }
                }
                return false;
            }
            return true;
        }

        #endregion
    }
}

