/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Everest.Library.Extensions;
namespace ExtjsForm.ExtForm.Controls
{
    public class FieldSet : ExtControlBase
    {
        public override string Name
        {
            get { return "FieldSet"; }
        }

        protected override string XType
        {
            get { return "fieldset"; }
        }
        protected override string RenderConfig(IColumn column)
        {
            StringBuilder itemsBuilder = new StringBuilder("forceLayout:true,layout: 'form',autoHeight:true,autoWidth:true,items:[");
            foreach (var item in column.Columns)
            {
                itemsBuilder.AppendFormat("{0},", item.Control.Render(item));
            }
            itemsBuilder.RemoveLastSpecifiedChar(',');
            itemsBuilder.Append("]");
            return itemsBuilder.ToString();
        }
    }
}

