/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;


using Everest.Library.Extensions;
namespace ExtjsForm.ExtForm.Controls
{
    public abstract class GroupControlBase : ExtControlBase
    {
        public override bool AvailableToSetLength
        {
            get
            {
                return false;
            }
        }
        public override bool AvailableToSetItems
        {
            get
            {
                return true;
            }
        }
        protected override string RenderConfig(ExtjsForm.IColumn column)
        {
            NameValueCollection items = ColumnHelper.ParseColumnItems(column.Items);
            StringBuilder stringBuilder = new StringBuilder("items: [");
            string[] defaultValues = column.DefaultValue.Split('|');
            foreach (string key in items.Keys)
            {
                bool bChecked = false;
                if (defaultValues.Contains<string>(items[key]))
                {
                    bChecked = true;
                }
                stringBuilder.AppendFormat("{{boxLabel:'{0}',name:'{1}', inputValue: '{2}',checked: {3}}},", key, column.Name, items[key], bChecked.ToString().ToLower());
            }
            stringBuilder.RemoveLastSpecifiedChar(',');
            stringBuilder.AppendFormat("]");
            return stringBuilder.ToString();
        }
    }
}

