/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExtjsForm.ExtForm.Controls
{
    public class Tinymce : ExtControlBase
    {
        public override string Name
        {
            get { return "Tinymce"; }
        }
        protected override string XType
        {
            get { return "tinymce"; }
        }
        protected override string RenderConfig(IColumn column)
        {
            StringBuilder stringBuilder = new StringBuilder(base.RenderConfig(column));
            stringBuilder.AppendFormat("width:600,height:500, tinymceSettings:{0}", @"{
							theme : ""advanced"",
							plugins: ""safari,pagebreak,style,layer,table,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,noneditable,visualchars,nonbreaking,xhtmlxtras,template"",
							theme_advanced_buttons1 : ""bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect"",
							theme_advanced_buttons2 : ""cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor"",
							theme_advanced_buttons3 : ""tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|"",
							theme_advanced_buttons4 : ""insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak"",
							theme_advanced_toolbar_location : ""top"",
							theme_advanced_toolbar_align : ""left"",
							theme_advanced_statusbar_location : ""bottom"",
							theme_advanced_resizing : false,
							extended_valid_elements : ""a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]"",
							template_external_list_url : ""example_template_list.js""
						}");
            return stringBuilder.ToString();
        }
    }
}

