/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExtjsForm.SchemaProvider
{
    public class Schema : ISchema
    {
        IList<IColumn> columns;
        public Schema()
        {
            this.columns = new List<IColumn>();

            this.GridAttributes = new System.Collections.Specialized.NameValueCollection();
            this.FormAttributes = new System.Collections.Specialized.NameValueCollection();
        }
        #region ISchema Members

        public string Name
        {
            get;
            set;
        }

        public IColumn[] Columns
        {
            get { return this.columns.ToArray(); }
        }

        public string UserName
        {
            get;
            set;
        }

        public void AddColumn(IColumn column)
        {
            this.columns.Add(column);
        }

        #endregion

        #region ISchema Members


        public string SubmitUrl
        {
            get;
            set;
        }

        public string DeleteUrl
        {
            get;
            set;
        }


        public string Title
        {
            get;
            set;
        }


        public string QueryUrl
        {
            get;
            set;
        }

        public string DetailsUrl
        {
            get;
            set;
        }

        #endregion

        #region ISchema Members


        public string GridType
        {
            get;
            set;
        }

        public string FormType
        {
            get;
            set;
        }

        #endregion

        #region ISchema Members


        public IEnumerable<SchemaRefrence> SchemaRefrences
        {
            get;
            set;
        }

        #endregion


        #region ISchema Members


        public System.Collections.Specialized.NameValueCollection GridAttributes
        {
            get;
            set;
        }

        public System.Collections.Specialized.NameValueCollection FormAttributes
        {
            get;
            set;
        }

        #endregion
    }
}

