﻿/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/

/// <reference path="ext/3.0/ext-base.js" />
/// <reference path="ext/3.0/ext-all-debug.js" />
/// <reference path="Resources.js" />

var regex = /^http:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\S*)?/i;
Ext.BLANK_IMAGE_URL = "Javascript/ext/3.0/resources/images/default/s.gif";
if (Ext.ux.CodePress)
    Ext.ux.CodePress.path = "Javascript/ext/ux/codepress/";
Global = function() {
    this._navigateTree = new Ext.tree.TreePanel({
        region: "west",
        id: "navigateTree",
        width: 200,
        title: Resources.NavigateTreeTitle,
        minSize: 160,
        maxSize: 300,
        margins: '5 0 0 3',
        cmargins: '5',
        collapsible: true,
        autoScroll: true,
        animate: true,
        enableDD: true,
        rootVisible: false,
        containerScroll: true,
//        plugins: new Everest.Cms.ContextMenu.NavigationTree(),
        loader: new Ext.tree.TreeLoader({
            dataUrl: 'form/GetTreeNodes'
        }),
        listeners: { click: function(node, e) {
            if (node.openedPanel) {
                node.openedPanel.show();
                return;
            }
            this.openFormByNode(node);
        },
            beforemovenode: function() {
                return false;
            },
            nodedrop: this.onNodedrop
       , scope: this
        }
    });
    var root = new Ext.tree.AsyncTreeNode({
        text: Resources.NavigateTreeTitle,
        draggable: false,
        id: '0',
        leaf: false
    });
    this._navigateTree.setRootNode(root);

    this._centerSpace = new Ext.TabPanel({
        region: 'center',
        deferredRender: false,
        activeTab: 0,
        resizeTabs: false,
        enableTabScroll: true,
        plugins: new Everest.plugins.TabCloseMenu(),
        listeners: { tabchange: function(tab, panel) {
            if (panel.opener && panel.opener.select)
                panel.opener.select();
        }, remove: function(tab, panel) {
            if (panel.opener != null) {
                var opener = panel.opener;
                delete opener.openedPanel;
                delete panel.opener;
            }
        }, scope: this
        }
    });
    this.openDefaultForm();
    this._viewPort = new Ext.Viewport({
        layout: 'border',
        plugins: new Everest.plugins.NonMenu(),
        items: [
        new Ext.Panel({ // raw
            region: 'north',
            html: Resources.logoHtml
        }), {
            region: 'west',
            id: 'west-panel',            
            split: true,
            width: 200,
            minSize: 175,
            maxSize: 400,
            collapsible: true,
            margins: '0 0 0 5',
            layout: 'accordion',
            layoutConfig: {
                animate: true
            },
            items: [this._navigateTree]
        },
            this._centerSpace
       ]
    });
    window.onbeforeunload = confirmExit;
    function confirmExit() {
        return Resources.confirmRefreshPage;
    }

}
Global.prototype = {
    addForm: function(form) {
        form.closable = true;
        this._centerSpace.add(form);
        this._centerSpace.setActiveTab(form);
        this._centerSpace.doLayout();
        return form;
    },
    openInMain: function(form) {
        this._centerSpace.un("remove", this.onFormClosed, this);
        form.closable = true;
        form.mainPanel = true;
        form.enableTabScroll = true;
        //if the form is FormPanel, doLayout will cause exception.
        if (form instanceof Ext.grid.GridPanel)
            form.on("render", function() { this._centerSpace.doLayout(); }, this);
        this._centerSpace.remove(this._centerSpace.items.first());
        this._centerSpace.insert(0, form);
        this._centerSpace.setActiveTab(form);
        this._centerSpace.on("remove", this.onFormClosed, this);

        return form;
    },
    openDefaultForm: function() {
        var startPage = this._centerSpace.insert(0, {
            xtype: 'panel',
            title: Resources.centerPanel,
            layout: 'fit',
            autoScroll: true
        });      
        this._centerSpace.setActiveTab(startPage);
    },
    onFormClosed: function(tabPanel, form) {
        if (form.mainPanel == true) {
            this.openDefaultForm();
        }
    },
    closeForm: function(form) {
        this._centerSpace.remove(form);
        // form.opener.
    },
    openFormByNode: function(node, newTab) {
        if (node.attributes["schema"]) {
            Global.Instance.getForm({
                params: { nodeId: node.id, folderUUID: node.attributes["folderUUID"], application: node.attributes["application"], schema: node.attributes["schema"], formType: node.attributes["formType"] || "grid" },
                formLoadParams: node.attributes, opener: node, newTab: newTab
            });
        }
    },
    onNodedrop: function(dropEvent) {
        var dropNode = dropEvent.dropNode;
        var targetNode = dropEvent.target;
        //folderType refer to enum FolderType
        if (targetNode.attributes["folderType"] == "BaseFolder") {
            if (targetNode.parentNode.attributes["folderType"] == dropNode.attributes["folderType"]) {
                this.saveDerive(targetNode, dropNode, { folderUUID: targetNode.parentNode.attributes["folderUUID"], Application: dropNode.attributes["application"], FolderName: dropNode.text });
            }
        }
        else if (targetNode.folderType = "DerivedFolder") {
            this.saveDerive(targetNode, dropNode, { folderUUID: dropNode.attributes["folderUUID"], Application: targetNode.parentNode.attributes["application"], FolderName: targetNode.parentNode.text });
        }
    },
    saveDerive: function(targetNode, sourceNode, params) {
        Ext.Ajax.request({
            url: "Folder/SubmitFolderDerived",
            success: function() {
                targetNode.reload();
                sourceNode.reload();
            },
            params: params,
            scope: this
        });
    },
    getTreeNodeById: function(id) {
        this._navigateTree.getNodeById(id);
    },
    getForm: function(config) {
        var node = this._navigateTree.getNodeById(config.params.nodeId);
        if (node != null) {
            if (!config.folderType) {
                config.folderType = node.attributes["folderType"];
            }
            config.params = Ext.apply(config.params, { "path": node.attributes["path"] });
        }
        var url = ActionUrl.normalFormUrl;
        var contentView = config.folderType == "ContentView" && config.params.formType == "form";
        if (config.folderType == "TextContentFolder" || contentView)
            url = ActionUrl.contentFormUrl;

        Ext.Ajax.request({
            url: url,
            success: function(o) {
                var form = Ext.decode(o.responseText);
                if (form.success == false) {
                    return;
                }
                if (config.opener) {
                    form.opener = config.opener;
                }
                if (form instanceof Ext.grid.GridPanel) {
                    config.opener.openedPanel = form;
                }
                if (config.formOption) {
                    config.formOption.params = Ext.apply(form.params, config.formOption.params);
                    Ext.apply(form, config.formOption);
                }
                if (config.formTitle) {
                    form.setTitle(config.formTitle);
                }
                if (config.popup == true) {
                    var win = new Ext.Window({
                        layout: 'fit',
                        width: 800,
                        height: 500,
                        resizable: true,
                        maximizable: true,
                        listeners: { maximize: function() { form.doLayout(); }, scope: this },
                        closeAction: 'close',
                        title: form.title,
                        iconCls: form.iconCls,
                        buttonAlign: 'center',
                        items: form
                    });
                    form.on("render", function() {
                        win.setTitle(form.title);
                        form.setTitle("");
                    });
                    form.setWindow(win);
                    //form.on("destroy", function() { win.close(); });
                    win.show();
                }
                else if (config.newTab == true) {
                    Global.Instance.addForm(form);
                }
                else {
                    Global.Instance.openInMain(form);
                }
                if (config.formLoadParams) {
                    form.load.defer(50, form, [config.formLoadParams, config.copyNew]);
                }
                if (contentView)
                    form.setReadonly(contentView);
                if (config.callback) {
                    config.callback.call(config.callbackScope || this, form);
                }
            },
            params: config.params
        });
    }
}
Ext.onReady(function() {
    var sp = new Ext.ux.state.PureObjectProvider();
    Ext.state.Manager.setProvider(sp);
    Ext.QuickTips.init();
    Ext.form.Field.prototype.msgTarget = 'under';
    Global.Instance = new Global();
})
Ext.override(Ext.Panel, {
    close: function() {
        Global.Instance.closeForm(this);
    }
});