﻿/*
Kooboo is a content management system based on ASP.NET MVC framework. Copyright 2009 Yardi Technology Limited.

This program is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.
If not, see http://www.kooboo.com/gpl3/.
*/
/// <reference path="ext/3.0/ext-base.js" />
/// <reference path="ext/3.0/ext-all-debug.js" />


/*override 3.0 compatibility to upload dialog  */
Ext.override(Ext.Component, {
    // private
    getStateId: function() {
        var id = Ext.id(this.id);
        return this.stateId || ((id.indexOf('ext-comp-') == 0 || id.indexOf('ext-gen') == 0) ? null : id);
    }
});
/*compatibility to upload dialog */
Ext.IFrameComponent = Ext.extend(Ext.BoxComponent, {
    url: '',
    doRefresh: function() {
        if (this.el.dom.src == this.url) {
            this.el.dom.contentWindow.location.reload();
        } else {
            this.el.dom.src = this.url;
        }
    },
    onRender: function(ct, position) {
        this.el = ct.createChild({ tag: 'iframe', id: 'iframe_' + this.id, frameBorder: 0, src: this.url, style: "background-color:#ffffff;" });
    },
    destroy: function() {
        this.el.dom.src = 'javascript:false;';
        Ext.removeNode(this.el.dom);
        Ext.IFrameComponent.superclass.destroy.call(this);
    }
});
/* In 3.0 ,the Menu.showAt will not fired the beforeshow event*/
Ext.sleep = function(delay) {
    var start = new Date().getTime();
    while (new Date().getTime() < start + delay);
}
Ext.override(Ext.menu.Menu, {
    enableScrolling: true,
    show: function(el, pos, parentMenu) {
        if (this.floating) {
            this.parentMenu = parentMenu;
            if (!this.el) {
                this.render();
                this.doLayout(false, true);
            }
            //if(this.fireEvent('beforeshow', this) !== false){
            this.showAt(this.el.getAlignToXY(el, pos || this.defaultAlign, this.defaultOffsets), parentMenu, false);
            //}
        } else {
            Ext.menu.Menu.superclass.show.call(this);
        }
    },
    showAt: function(xy, parentMenu, _e) {
        if (this.fireEvent('beforeshow', this) !== false) {
            this.parentMenu = parentMenu;
            if (!this.el) {
                this.render();
            }
            if (_e !== false) {
                xy = this.el.adjustForConstraints(xy);
            }
            this.el.setXY(xy);
            if (this.enableScrolling) {
                this.constrainScroll(xy[1]);
            }
            this.el.show();
            Ext.menu.Menu.superclass.onShow.call(this);
            if (Ext.isIE) {
                this.layout.doAutoSize();
                if (!Ext.isIE8) {
                    this.el.repaint();
                }
            }
            this.hidden = false;
            this.focus();
            this.fireEvent("show", this);
        }
    }
});
Ext.util.Format.date = function(v, format, f2, f, t) {
    if (!v || v == '/Date(-6816297600000)/' || v == '/Date(-62135596800000)/') {
        return "";
    }
    if (!(v instanceof Date)) {
        vDate = v.replace(/\/Date\(([0-9]+)\)\//ig, '$1');
        if (vDate != '' && vDate != v) {
            v = new Date(parseInt(vDate));
        }
        else {
            v = Date.parseDate(v, "Y-m-d");
        }

    }
    return v.dateFormat("Y-m-d");
}
//日期加时间格式
Ext.util.Format.dateTime = function(v, format, f2, f, t) {
    if (!v || v == '/Date(-6816297600000)/' || v == '/Date(-62135596800000)/') {
        return "";
    }
    if (!(v instanceof Date)) {
        vDate = v.replace(/\/Date\(([0-9]+)\)\//ig, '$1');
        if (vDate != '' && vDate != v) {
            v = new Date(parseInt(vDate));
        }
        else {
            v = Date.parseDate(v, "Y-m-d H:i:s");
        }

    }
    if (v)
        return v.dateFormat("Y-m-d H:i:s");
    return v;
}
Ext.util.Format.link = function(value, metadata, record, rowIndex, colIndex, store) {
    if (!value) return '';
    return String.format("<a href='{0}' target='_blank'><img src='/Styles/Images/preview.png' alt='{1}'/></a>", value, Resources.preview);
}
Ext.util.Format.img = function(value, metadata, record, rowIndex, colIndex, store) {
    return String.format("<img src='{0}' />", value);
}
Ext.util.Format.KB = function(value, metadata, record, rowIndex, colIndex, store) {
    value = parseFloat(value);
    if (value == 0)
        return '';
    value = value / 1024;
    if (value < 1)
        return '1KB';
    value = Math.ceil(value);
    return value.toString().replace(/(\d{1,3})(?=(\d{3})+(?:$|\.))/g, "$1,") + 'KB';
}
Ext.util.Format.formatBoolean = function(value, metadata, record, rowIndex, colIndex, store) {
    var img = "/Styles/Images/cross.png";
    if (value == true) {
        img = "/Styles/Images/tick.png";
    }
    else {
        img = "/Styles/Images/cross.png";
    }
    return String.format("<img src='{0}' alt='{1}'/>", img, value);
}

Ext.form.VTypes["alphanumdotVal"] = /^[a-zA-Z0-9_\.]+$/;
Ext.form.VTypes["alphanumdotMask"] = /[a-z0-9_\.]/i;
Ext.form.VTypes["alphanumdotText"] = 'This field should only contain letters, numbers and _ and . ';
Ext.form.VTypes["alphanumdot"] = function(v) {
    return Ext.form.VTypes["alphanumdotVal"].test(v);
}
Ext.form.VTypes["imageVal"] = /.*(\.[Jj][Pp][Gg]|\.[Gg][Ii][Ff]|\.[Jj][Pp][Ee][Gg]|\.[Pp][Nn][Gg])/;
Ext.form.VTypes["imageText"] = 'The file is invalid.';
Ext.form.VTypes["image"] = function(v) {
    return Ext.form.VTypes["imageVal"].test(v);
}
//http://extjs.com/forum/showthread.php?t=4271
Ext.form.VTypes["hostnameVal1"] = /^[a-zA-Z][-.a-zA-Z0-9]{0,254}$/;
Ext.form.VTypes["hostnameVal2"] = /^[a-zA-Z]([-a-zA-Z0-9]{0,61}[a-zA-Z0-9]){0,1}([.][a-zA-Z]([-a-zA-Z0-9]{0,61}[a-zA-Z0-9]){0,1}){0,}$/;
Ext.form.VTypes["ipVal"] = /^([1-9][0-9]{0,1}|1[013-9][0-9]|12[0-689]|2[01][0-9]|22[0-3])([.]([1-9]{0,1}[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){2}[.]([1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-4])$/;
Ext.form.VTypes["netmaskVal"] = /^(128|192|224|24[08]|25[245].0.0.0)|(255.(0|128|192|224|24[08]|25[245]).0.0)|(255.255.(0|128|192|224|24[08]|25[245]).0)|(255.255.255.(0|128|192|224|24[08]|252))$/;
Ext.form.VTypes["portVal"] = /^(0|[1-9][0-9]{0,3}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$/;
Ext.form.VTypes["multicastVal"] = /^((22[5-9]|23[0-9])([.](0|[1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3})|(224[.]([1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-5])([.](0|[1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-5])){2})|(224[.]0[.]([1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-5])([.](0|[1-9][0-9]{0,1}|1[0-9]{2}|2[0-4][0-9]|25[0-5])))$/;
Ext.form.VTypes["usernameVal"] = /^[a-zA-Z][-_.a-zA-Z0-9]{0,30}$/;
Ext.form.VTypes["passwordVal1"] = /^.{6,31}$/;
Ext.form.VTypes["passwordVal2"] = /[^a-zA-Z].*[^a-zA-Z]/;
Ext.form.VTypes["hostname"] = function(v) {
    if (!Ext.form.VTypes["hostnameVal1"].test(v)) {
        Ext.form.VTypes["hostnameText"] = "Must begin with a letter and not exceed 255 characters"
        return false;
    }
    Ext.form.VTypes["hostnameText"] = "L[.L][.L][.L][...] where L begins with a letter, ends with a letter or number, and does not exceed 63 characters";
    return Ext.form.VTypes["hostnameVal2"].test(v);
}
Ext.form.VTypes["hostnameText"] = "Invalid Hostname"
Ext.form.VTypes["hostnameMask"] = /[-.a-zA-Z0-9]/;
Ext.form.VTypes["ip"] = function(v) {
    return Ext.form.VTypes["ipVal"].test(v);
}
Ext.form.VTypes["ipText"] = "1.0.0.1 - 223.255.255.254 excluding 127.x.x.x"
Ext.form.VTypes["ipMask"] = /[.0-9]/;
Ext.form.VTypes["netmask"] = function(v) {
    return Ext.form.VTypes["netmaskVal"].test(v);
}
Ext.form.VTypes["netmaskText"] = "128.0.0.0 - 255.255.255.252"
Ext.form.VTypes["netmaskMask"] = /[.0-9]/;
Ext.form.VTypes["port"] = function(v) {
    return Ext.form.VTypes["portVal"].test(v);
}
Ext.form.VTypes["portText"] = "0 - 65535"
Ext.form.VTypes["portMask"] = /[0-9]/;
Ext.form.VTypes["multicast"] = function(v) {
    return Ext.form.VTypes["multicastVal"].test(v);
}
Ext.form.VTypes["multicastText"] = "224.0.1.0 - 239.255.255.255"
Ext.form.VTypes["multicastMask"] = /[.0-9]/;
Ext.form.VTypes["username"] = function(v) {
    return Ext.form.VTypes["usernameVal"].test(v);
}
Ext.form.VTypes["usernameText"] = "Username must begin with a letter and cannot exceed 255 characters"
Ext.form.VTypes["usernameMask"] = /[-_.a-zA-Z0-9]/;
Ext.form.VTypes["password"] = function(v) {
    if (!Ext.form.VTypes["passwordVal1"].test(v)) {
        Ext.form.VTypes["passwordText"] = "Password length must be 6 to 31 characters long";
        return false;
    }
    Ext.form.VTypes["passwordText"] = "Password must include atleast 2 numbers or symbols";
    return Ext.form.VTypes["passwordVal2"].test(v);
}
Ext.form.VTypes["passwordText"] = "Invalid Password"
Ext.form.VTypes["passwordMask"] = /./;

Ext.form.VTypes["phone"] = /^(\d{3}[-]?){1,2}(\d{4})$/;
Ext.form.VTypes["phoneMask"] = /[\d-]/;
Ext.form.VTypes["phoneText"] = 'Not a valid phone number.  Must be in the format 123-4567 or 123-456-7890 (dashes optional)';
//
Ext.override(Ext.form.RadioGroup, {
    setValue: function(value) {
        this.items.each(function(i) {
            i.setValue(false);
        });
        this.items.each(function(i) {
            if (i.inputValue == value)
                i.setValue(true);
        });
    }
})
Ext.override(Ext.form.CheckboxGroup, {
    setValue: function(value) {
        this.items.each(function(i) {
            i.setValue(false);
        });
        this.items.each(function(i) {
            if (value.indexOf(i.inputValue) != -1)
                i.setValue(true);
        });
    }
})
//extent treeloader ,support load node children from node's url property
Ext.override(Ext.tree.TreeLoader, {
    requestData: function(node, callback) {
        if (this.fireEvent("beforeload", this, node, callback) !== false) {
            this.transId = Ext.Ajax.request({
                method: this.requestMethod,
                url: this.getUrl(node),
                success: this.handleResponse,
                failure: this.handleFailure,
                scope: this,
                argument: { callback: callback, node: node },
                params: this.getParams(node)
            });
        } else {
            if (typeof callback == "function") {
                callback();
            }
        }
    },
    getParams: function(node) {
        var buf = [], bp = this.baseParams;
        for (var key in bp) {
            if (typeof bp[key] != "function") {
                buf.push(encodeURIComponent(key), "=", encodeURIComponent(bp[key]), "&");
            }
        }
        for (var a in node.attributes) {
            if (typeof (node.attributes[a]) != "object")
                buf.push(encodeURIComponent(a), "=", encodeURIComponent(node.attributes[a]), "&");
        }
        return buf.join("");
    },
    getUrl: function(node) {
        if (node.attributes["dataUrl"])
            return node.attributes["dataUrl"];
        return this.dataUrl || this.url;
    }
})
Ext.override(Ext.form.Field, {
    //depency example
    //{param:'param1',fieldId:'field1'}
    //{param:'param2',formProperty:'applicaiton'}
    //[{param:'param1',fieldId:'field1'},{param:'param2',formProperty:'applicaiton'}]
    getDepencyParams: function() {
        var params = null;
        if (this.depencies) {
            Ext.each(this.depencies, function(d) {
                var p = {};
                p[d.paramName] = d.control.getValue();
                params = Ext.apply(params || {}, p);
            });
        }
        if (this.depency) {
            if (this.depency instanceof Array) {
                for (var i = 0; i < this.depency.length; i++) {
                    var depencyObj = this.depency[i];
                    if (depencyObj.formProperty) {
                        var p = {};
                        p[depencyObj.param] = this.ownerCt[depencyObj.formProperty];
                        params = Ext.apply(params || {}, p);
                    }
                }
            }
            else {
                if (this.depency.formProperty && this.ownerCt) {
                    var p = {};
                    p[this.depency.param] = this.ownerCt[this.depency.formProperty];
                    params = Ext.apply(params || {}, p);
                }
            }
        }
        return params;
    },
    setDepencyControl: function(depencyObj) {
        if (!this.depencies)
            this.depencies = new Array();
        this.depencies.push(depencyObj);
        depencyObj.control.addDepencied(this);
    },
    addDepencied: function(field) {
        if (this.depencied == undefined)
            this.depencied = new Array();
        if (this.depencied.indexOf(field) == -1)
            this.depencied.push(field);
        this.un('change', this.onChange, this);
        this.on('change', this.onChange, this);
    },
    onChange: function() {
        if (this.depencied)
            Ext.each(this.depencied, function(d) {
                d.reset();
            }, this);
    },
    findParentByContainerType: function() {
        return this.findParentBy(function(container, component) {
            if (container.containerType) return container;
        }, this);
    },
    beforeDestroy: function() {
        Ext.form.Field.superclass.beforeDestroy.call(this);
        delete this.depencyControl;
        delete this.depencied;
    },
    onRender: function(ct, position) {
        //below code is different form extjs 2.2 to 3.0.
        if (!this.el) {
            var cfg = this.getAutoCreate();

            if (!cfg.name) {
                cfg.name = this.name || this.id;
            }
            if (this.inputType) {
                cfg.type = this.inputType;
            }
            this.autoEl = cfg;
        }
        Ext.form.Field.superclass.onRender.call(this, ct, position);

        var type = this.el.dom.type;
        if (type) {
            if (type == 'password') {
                type = 'text';
            }
            this.el.addClass('x-form-' + type);
        }
        if (this.readOnly) {
            this.el.dom.readOnly = true;
        }
        if (this.tabIndex !== undefined) {
            this.el.dom.setAttribute('tabIndex', this.tabIndex);
        }

        this.el.addClass([this.fieldClass, this.cls]);

        if (this.initialConfig.rightLabel) {
            this.rightLableEl = ct.createChild({ tag: 'span', cls: this.rightLabelClass, html: this.initialConfig.rightLabel });
            this.rightLableEl.setDisplayed(false);
            this.on("focus", this.setRightLabelDisplayed, this);
            this.on("blur", this.setRightLabelHidden, this);
        }
    },
    setRightLabelDisplayed: function(field) {
        if (this.rightLableEl) {
            this.rightLableEl.setDisplayed(true);
        }
    },
    setRightLabelHidden: function(field) {
        if (this.rightLableEl) {
            this.rightLableEl.setDisplayed(false);
        }
    },
    rightLabelClass: 'x-form-rightLabel'
})
Ext.override(Ext.form.TextField, {
    reset: function() {
        var depencyParams = this.getDepencyParams();
        if (depencyParams && this.url) {
            var p = {};
            Ext.apply(p, depencyParams);
            Ext.Ajax.request({
                url: this.url,
                success: function(response) { this.setValue(response.responseText) },
                scope: this,
                params: p
            });
        }
        Ext.form.TextField.superclass.reset.call(this);
    }
});
Ext.override(Ext.form.DateField, {
    format: "Y-m-d",
    initComponent: function() {
        Ext.form.DateField.superclass.initComponent.call(this);
        if (typeof this.minValue == "string") {
            this.minValue = this.parseDate(this.minValue);
        }
        if (typeof this.maxValue == "string") {
            this.maxValue = this.parseDate(this.maxValue);
        }
        this.ddMatch = null;
        this.initDisabledDays();
        if (this.defaultToday) {
            this.value = (new Date());
        }
    },
    setValue: function(date) {
        date = Ext.util.Format.date(date);
        Ext.form.DateField.superclass.setValue.call(this, this.formatDate(this.parseDate(date)));
    }
});
Ext.override(Ext.ux.form.DateTime, {
    dateFormat: 'Y-m-d',
    setValue: function(val) {
        val = date = Ext.util.Format.dateTime(val);
        if (!val && true === this.emptyToNow) {
            this.setValue(new Date());
            return;
        }
        else if (!val) {
            this.setDate('');
            this.setTime('');
            this.updateValue();
            return;
        }
        if ('number' === typeof val) {
            val = new Date(val);
        }
        else if ('string' === typeof val && this.hiddenFormat) {
            val = Date.parseDate(val, this.hiddenFormat)
        }
        val = val ? val : new Date(1970, 0, 1, 0, 0, 0);
        var da, time;
        if (val instanceof Date) {
            this.setDate(val);
            this.setTime(val);
            this.dateValue = new Date(val);
        }
        else {
            da = val.split(this.dtSeparator);
            this.setDate(da[0]);
            if (da[1]) {
                if (da[2]) {
                    // add am/pm part back to time
                    da[1] += da[2];
                }
                this.setTime(da[1]);
            }
        }
        this.updateValue();
    }
});
Ext.override(Ext.form.TimeField, {
    tpl: ''//use the default tpl.
});
Ext.override(Ext.form.ComboBox, {
    tpl: '<tpl for="."><div class="x-combo-list-item"><tpl if="Image"><img src="{Image}" alt="{ImageAlt}"/></tpl> {Name}</div></tpl>',
    findRecord: function(prop, value) {
        var record;
        //this.store will be null.
        if (this.store && this.store.getCount() > 0) {
            this.store.each(function(r) {
                if (r.data[prop] == value) {
                    record = r;
                    return false;
                }
            });
        }
        return record;
    },
    //
    //重写 setValue 方法，是为了解决在查看数据时，值赋到Combobox上，不会自动去查询，会以值的形式显示，对用户是不友好。
    //
    setValue: function(v) {
        if (v == null || this.store == null) {
            return;
        }
        var text = v;
        //当v等于空字符串时，也不去请求，
        //因为当combobox在EditorGrid中时，默认都会设空字符串
        if (v != null && v.toString() != '' && this.mode == 'remote' && this.lastQuery == undefined) {
            this.lastQuery = '';
            this.store.load({

                scope: this,

                params: this.getParams(),

                callback: function() {

                    this.setValue(v)

                }
            })

        }

        if (this.valueField && this.store) {

            var r = this.findRecord(this.valueField, v);

            if (r) {

                text = r.data[this.displayField];

            } else if (this.valueNotFoundText !== undefined) {

                text = this.valueNotFoundText;

            }

        }

        this.lastSelectionText = text;

        if (this.hiddenField) {

            this.hiddenField.value = v;

        }

        Ext.form.ComboBox.superclass.setValue.call(this, text);

        this.value = v;

    },
    getParams: function(q) {
        var p = {};
        if (this.pageSize) {
            p.start = 0;
            p.limit = this.pageSize;
        }
        //        if (this.ownerCt.getfolderUUID()) {
        //            p["folderUUID"] = this.nodeId;
        //        }
        //custom code.
        var folderUUID = this.node;

        if (folderUUID == undefined) {
            var ownerct = this.ownerCt;
            while (folderUUID == undefined && ownerct != undefined) {
                if (ownerct.getfolderUUID) {
                    folderUUID = ownerct.getfolderUUID();
                    break;
                }
                ownerct = ownerct.ownerCt;
            }
        }
        if (folderUUID) {
            this.getStore().baseParams["folderUUID"] = folderUUID;
        }
        var application = this.application;
        if (application == undefined) {
            var ownerct = this.ownerCt;
            while (folderUUID == undefined && ownerct != undefined) {
                if (ownerct.getApplication) {
                    application = ownerct.getApplication();
                    break;
                }
                ownerct = ownerct.ownerCt;
            }
        }
        if (application) {
            this.getStore().baseParams["application"] = application;
        }
        var depencyParams = this.getDepencyParams();
        if (this.depency && depencyParams) {
            Ext.apply(this.getStore().baseParams, depencyParams);
        }
        return p;
    },
    reset: function() {
        //        this.lastQuery = "anything";
        //        this.doQuery("", true);
        //reset ;当用户选择时再查询。
        this.triggerAction = "all";
        this.lastQuery = (new Date()).toString();
        this.setValue("");

        //Ext.form.ComboBox.superclass.reset.call(this);
    }
})
Ext.override(Ext.ux.form.LovCombo, {
    tpl: null,
    setCheckedValue: function() {
        this.value = this.getCheckedValue();
        this.setRawValue(this.getCheckedDisplay());
        if (this.hiddenField) {
            this.hiddenField.value = this.value;
        }
    },
    setValue: function(v) {
        if (v) {
            v = '' + v;
            if (this.valueField) {
                if (this.list != undefined) {
                    this.setCheckedValue();
                }
                else if (this.mode == "local") {
                    this.store.clearFilter();
                    //原来this.list != undefined || this.mode == "local"
                    //为了解决，相同标题的其中一条被选中，其它记录也会被选择的问题，下面这段代码要注释
                    this.store.each(function(r) {
                        var checked = !(!v.match(
						     '(^|' + this.separator + ')' + RegExp.escape(r.get(this.valueField))
						    + '(' + this.separator + '|$)'))
					    ;

                        r.set(this.checkField, checked);
                    }, this);
                    this.setCheckedValue();
                }
                else {
                    this.store.on('load', function() {
                        this.store.each(function(r) {
                            var checked = !(!v.match(
						         '(^|' + this.separator + ')' + RegExp.escape(r.get(this.valueField))
						        + '(' + this.separator + '|$)'))
					        ;

                            r.set(this.checkField, checked);
                        }, this);
                        this.setCheckedValue();
                    }, this);
                    this.doQuery("", true);
                }
            }
            else {
                this.value = v;
                this.setRawValue(v);
                if (this.hiddenField) {
                    this.hiddenField.value = v;
                }
            }
            if (this.el) {
                this.el.removeClass(this.emptyClass);
            }
        }
        else {
            //在下拉框显示后，移开焦点，设已选择的值。
            this.setCheckedValue();
            //    this.clearValue();
        }
    },
    reset: function() {
        //reset ;当用户选择时再查询。
        this.triggerAction = "all";
        this.lastQuery = (new Date()).toString();
        this.clearValue("");
    }
})
Ext.override(Ext.form.Action, {
    getParams: function() {
        var bp = this.form.baseParams;
        var p = this.options.params;
        if (p) {
            if (typeof p == "object") {
                //replace Ext.applyIf to Ext.apply, use in Everest.MasterFormPanel when the child form changed after first submit.
                p = Ext.urlEncode(Ext.apply(p, bp));
            } else if (typeof p == 'string' && bp) {
                p += '&' + Ext.urlEncode(bp);
            }
        } else if (bp) {
            p = Ext.urlEncode(bp);
        }
        return p;
    }
});
Ext.Ajax.on("requestcomplete", function(conn, response, options) {
    if (response.getResponseHeaderresp && response.getResponseHeader["RedirectToLogin"] == 1) {
        Ext.MessageBox.show({ title: Resources.authenticationExpiredTitle,
            msg: Resources.authenticationExpiredMsg,
            buttons: Ext.MessageBox.OK,
            icon: Ext.MessageBox.WARNING,
            width: 300
        });
    }
    else {
        //judge whether the rquest is success or failure.
        var responseText = response.responseText;
        if (responseText.indexOf('{"success":false,') == 0) {
            var data = Ext.decode(response.responseText);
            if (data.message)
                Everest.showErrorMessage(data.message);
            else if (data.warning) {
                Everest.showWarning(data.warning);
            }
            //不能退出，退出后，后缓事件不被执行。 
            //  return;
        }
    }
});
Ext.Ajax.on("requestexception", function(conn, response, options) {
    Everest.showErrorMessage(Resources.networkError);
});

Ext.override(Ext.form.BasicForm, {
    initComponent: function() {
        this.addEvents(
            'beforeSetValues',
            'afterSetValues'
        );
    },
    setValues: function(values) {
        this.fireEvent('beforeSetValues', this, values);

        if (Ext.isArray(values)) { // array of objects
            for (var i = 0, len = values.length; i < len; i++) {
                var v = values[i];
                var f = this.findField(v.id);
                if (f) {
                    f.setValue(v.value);
                    if (this.trackResetOnLoad) {
                        f.originalValue = f.getValue();
                    }
                }
            }
        } else { // object hash
            var field, id;
            for (id in values) {
                if (typeof values[id] != 'function' && (field = this.findField(id))) {
                    field.setValue(values[id]);
                    if (this.trackResetOnLoad) {
                        field.originalValue = field.getValue();
                    }
                }
            }
        }

        this.fireEvent('afterSetValues', this, values);
        return this;

    }
});