﻿
/*
*
* Ext.ux.CodeMirror.data
*
*/

Ext.namespace('Ext.ux');

Ext.ux.getIntelligentDataStore = function() {
    var store = Ext.ux.intelligentDataStore;
    if (store) {
        return store;
    }
    // datas
    var dataArray = [
    // js
    ['', 'if'],
    ['', 'var'],
    ['', 'for'],
    ['', 'else'],
    ['', 'true'],
    ['', 'this'],
    ['', 'with'],
    ['', 'null'],
    ['', 'case'],
    ['', 'false'],
    ['', 'break'],
    ['', 'switch'],
    ['', 'typeof'],
    ['', 'return'],
    ['', 'continue'],
    ['', 'function'],
    ['', 'undefined'],
    ['', 'javascript'],
    // window
    ['', 'window'],
    ['window', 'close()'],
    ['window', 'document'],
    ['window', 'location'],
    // document
    ['', 'document'],
    ['document', 'body'],
    ['document', 'forms'],
    ['document', 'removeChild(el)'],
    ['document', 'appendChild(el)'],
    ['document', 'getElementById(id)'],
    ['document', 'getElementsByTagName(tag)'],
    ['document', 'getElementsByName(name)'],
    //Top
    ['', 'PageSize'],
    ['this', 'PageSize'],
    ['', 'PageIndex'],
    ['this', 'PageIndex'],
    ['', 'TotalCount'],
    ['this', 'TotalCount'],

    ['this', 'GetContent(viewDataKey)'],
    ['this', 'GetContents(viewDataKey)'],
    ['this', 'GetSubContents(viewDataKey,subContentSchemaName)'],
    ['this', 'GetResource(key)'],
    ['this', 'GetResource(key,defaultValue)'],
    ['this', 'GetResource(namespace,key,defaultValue)'],

['this', 'RenderContentTemplateByName(contentTemplateName)'],
['this', 'RenderContentTemplateByName(contentTemplateName, propertySettings)'],
['this', 'RenderContentTemplateByUUID(contentTemplateUUID)'],
['this', 'RenderContentTemplateByUUID(contentTemplateUUID,propertySettings)'],

    // Url
    ['', 'Url'],
    ['this', 'Url'],
    ['Url', 'PageUrl(PageName)'],
    ['Url', 'PageUrl(PageName, values)'],
    ['Url', 'PageUrl(PageName,useDefaultValues)'],
    ['Url', 'ResolveUrl(url)'],
    ['Url', 'DynamicPageUrlForBinary(ContentId)'],
    ['Url', 'DynamicPageUrlForBinary(ContentId, Order)'],
    ['UrlHelper', 'PageUrl(PageName)'],
    ['UrlHelper', 'PageUrl(PageName, values)'],
    ['UrlHelper', 'PageUrl(PageName,useDefaultValues)'],
    ['UrlHelper', 'ResolveUrl(url)'],
    ['UrlHelper', 'DynamicPageUrlForBinary(ContentId)'],
    ['UrlHelper', 'DynamicPageUrlForBinary(ContentId, Order)'],

    //HTML
    ['', 'Html'],
    ['this', 'Html'],
    ['Html', 'PageLink(linkText, pageName)'],
    ['Html', 'PageLink(linkText,bool useDefaultValues)'],
    ['Html', 'PageLink(linkText,bool useDefaultValues,object htmlAttributes)'],
    ['Html', 'PageLink(linkText,object routeValues)'],
    ['Html', 'PageLink(linkText,object routeValues,object htmlAttributes)'],
    ['Html', 'CmsPager(pageSize,currentPage,totalItemCount)'],
    ['Html', 'CmsPager(pageSize,currentPage,totalItemCount,routeValues)'],
    ['Html', 'CmsPager(pageSize,currentPage,totalItemCount,pageIndexName)'],
    ['Html', 'CmsPager(pageSize,currentPage,totalItemCount,routeValues)'],
    ['Html', 'CmsPager(pageSize,currentPage,totalItemCount,pageIndexName,routeValues)'],
    // CmsContext
    ['', 'CmsContext'],
    ['this', 'CmsContext'],
    ['CmsContext', 'Cms_Application'],
    ['CmsContext', 'Cms_Page'],
    ['CmsContext', 'ContentService'],
    ['CmsContext', 'FolderHelper'],
    ['CmsContext', 'IsDesignMode'],
    ['CmsContext', 'PageHelper'],
    ['CmsContext', 'PageRouteData'],
    ['CmsContext', 'SearchService'],
    ['CmsContext', 'UrlHelper'],
    ['CmsContext', 'User'],
    // Application
    ['', 'Cms_Application'],
    ['this', 'Cms_Application'],
    ['Cms_Application', 'ApplicationId'],
    ['Cms_Application', 'ApplicationName'],
    //Cms_Page
    ['', 'Cms_Page'],
    ['this', 'Cms_Page'],
    ['Cms_Page', 'PageName'],
    ['Cms_Page', 'IsTop'],
    ['Cms_Page', 'LinkText'],
    ['Cms_Page', 'ShowInNavigation'],
    //FolderHelper
    ['', 'FolderHelper'],
    ['FolderHelper', 'GetFolder(folderName)'],
    ['FolderHelper', 'GetFoldersBySchema(schemaName)'],
    // ContentService
    ['', 'ContentService'],
    ['this', 'ContentService'],
    ['ContentService', 'AddContent(folderName, schemaName, userName, values, files)'],
    ['ContentService', 'AddSubContent(parentUUID, schemaName, userName, values, files)'],
    ['ContentService', 'AddSubContent(parentId, schemaName, userName, values, files)'],
    ['ContentService', 'GetAttachments(contentId)'],
    ['ContentService', 'GetBinaryContentById(contentId, cacheTime)'],
    ['ContentService', 'GetBinaryContentByUUID(contentUUID, cacheTime)'],
    ['ContentService', 'GetBinaryContentCount(folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetBinaryContents(folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetCategoriesByContentAndFolder(contentUUID, folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetCategoriesByContentAndFolder(contentId, folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetCategoriesByContentAndSchema(contentUUID, schemaName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetCategoriesByContentAndSchema(contentId, schemaName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetCategoryCountByContentAndFolder(contentUUID, folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetCategoryCountByContentAndFolder(contentId, folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetCategoryCountByContentAndSchema(contentUUID, schemaName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetCategoryCountByContentAndSchema(contentId, schemaName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContent(schema, queryStatement, parameters, cacheTime)'],
    ['ContentService', 'GetContentById(contentId, cacheTime)'],
    ['ContentService', 'GetContentByUserKey(userKey, cacheTime)'],
    ['ContentService', 'GetContentByUUID(contentUUID, cacheTime)'],
    ['ContentService', 'GetContentCountByCategoryAndFolder(categoryOriginalUUID, folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContentCountByCategoryAndFolder(categoryId, folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContentCountByCategoryAndSchema(categoryOriginalUUID, schemaName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContentCountByCategoryWithSchema(categoryId, schemaName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContentCountByFolder(folderName, queryStatement, queryValues, cacheTime)'],
    ['ContentService', 'GetContentCountBySchema(schemaName, cacheTime)'],
    ['ContentService', 'GetContentsByCategoryAndFolder(categoryOriginalUUID, folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetContentsByCategoryAndFolder(categoryId, folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetContentsByCategoryAndSchema(categoryOriginalUUID, schemaName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetContentsByCategoryAndSchema(categoryId, schemaName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetContentsByFolder(folderName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetContentsBySchema(schemaName, queryStatement, orderBy, queryValues, startIndex, pageSize, cacheTime)'],
    ['ContentService', 'GetFolder(folderName)'],
    ['ContentService', 'GetSchema(schemaName)'],
    // SearchService
    ['', 'SearchService'],
    ['this','SearchService'],
    ['SearchService', 'Search(key, pageIndex, pageSize, out totalCount)'],
    ['SearchService', 'Search(key, category, searchBaseApps, pageIndex, pageSize, out totalCount)'],
    //PageHelper
    ['', 'PageHelper'],
    ['this', 'PageHelper'],
    ['PageHelper', 'GetNavigations(Guid? parentUUID)'],
    ['PageHelper', 'GetParentNavigation(Guid pageUUID)'],
    ['PageHelper', 'GetSubNavigations()'],
    ['PageHelper', 'GetTopNavigations()'],
    //new
    ['', 'new ContentPagedList(contents, totalItemCount, pageSize, pageIndex)']
    ];


    // add id field value auto
    for (var i = 0; i < dataArray.length; i++) {
        var item = dataArray[i];
        item.unshift(i);
    }
    // get
    store = Ext.ux.intelligentDataStore = new Ext.data.ArrayStore({
        id: 0,
        fields: ['Id', 'Parent', 'Display'],
        systemFields: {
            valueField: 'Id',
            parentField: 'Parent',
            displayField: 'Display'
        },
        data: dataArray
    });
    return store;
};