﻿
/*
 *
 * Ext.ux.radEditor
 * 
 */

(function() {

    Ext.namespace('Ext.ux');

    Ext.ux.radEditor = function(config) {
        this.addEvents({ "radcreated": true });
        Ext.ux.radEditor.superclass.constructor.call(this, config);
        Ext.ux.radEditor.add(this);
    };

    Ext.extend(Ext.ux.radEditor, Ext.form.Field, {
        mode: 'full', //full or simlple
        defaultAutoCreate: {
            tag: 'textarea',
            autocomplete: 'off'
        },
        initComponent: function() {
            //TODO: init language
        },
        initValue: function() {
            if (this.value !== undefined) {
                this.setValue(this.value);
            } else {
                var val = this.el.dom.value;
                if (val)
                    this.setValue(val);
            }
        },
        getValue: function() {
            if (!this.rendered || !this.rad || !this.rad._initialized)
                return this.value;

            var v = this.rad.get_html();
            if (v === this.emptyText || v === undefined) {
                v = '';
            }
            return v;
        },
        setValue: function(v) {
            if (!v) v = '';
            this.value = v;
            if (this.rendered) {
                this.withRad(function() {
                    this.rad.set_html(v);
                    this.validate();
                });
            }
        },
        saveToTextarea: function() {
            if (this.rendered)
                this.el.dom.value = this.rad.get_html();
        },
        getName: function() {
            return this.rendered && this.el.dom.name ? this.el.dom.name : (this.name || '');
        },
        onRender: function(ct, position) {
            Ext.ux.radEditor.superclass.onRender.call(this, ct, position);
            this.el.dom.style.border = '0 none';
            this.el.dom.setAttribute('tabIndex', -1);
            this.el.addClass('x-hidden');
            if (this.name) {
                this.el.set({ name: this.name });
            }
            if (Ext.isIE) {
                this.el.applyStyles('margin-top:-1px;margin-bottom:-1px;');
            }
            this.wrap = this.el.wrap({
                cls: 'x-html-editor-wrap', cn: { cls: 'x-html-editor-tb' }
            });
            this.wrap.setWidth(this.width + 4);
            this.wrap.dom.firstChild.innerHTML = '<span style="font-size: 14px;">loading editor...</span>';
            Ext.Ajax.request({
                url: this.mode.toLowerCase() == 'full' ? '../Telerik/RadEditor' : '../Telerik/RadEditorSimple',
                success: function(response) {
                    var host = this, allReg = new RegExp('RadEditor1', 'g'), rId = 'rid' + Math.random().toString().substr(2, 4);
                    //Html
                    var html = this.getHtml(response.responseText);
                    this.wrap.dom.firstChild.innerHTML = html.replace(allReg, rId);
                    //Scripts
                    var script = this.getScript(response.responseText);
                    eval(script.replace(allReg, rId));
                    //Hint
                    this.rad = $find(rId);
                    //this.hint = new CapacityHint(this.rad);
                    //Fix Style
                    if (dlg = this.rad.get_dialogOpener()) {
                        dlg.add_open(function(sender, args) {
                            host.fixStyle();
                        });
                    }
                    //Event
                    this.fireEvent("radcreated");
                },
                failure: function() {
                    this.wrap.dom.firstChild.innerHTML = '<span style="font-size: 14px;">editor failure !</span>';
                },
                params: { Mode: this.mode },
                scope: this
            });
        },
        destroy: function() {
            if (this.rad) {
                if (dlgOpener = $find(this.rad._uniqueID + 'dialogOpener'))
                    dlgOpener.dispose();
                if (dlgOpenerWin = $find(this.rad._uniqueID + 'dialogOpener_Window'))
                    dlgOpenerWin.dispose();
                Ext.ux.radEditor.remove(this);
                this.rad.dispose();
            }
            Ext.ux.radEditor.superclass.destroy.call(this);
        },
        getScript: function(html) {
            var start = html.lastIndexOf('Sys.Application.initialize();'), end = html.lastIndexOf('</script>');
            return html.substring(start, end);
        },
        getHtml: function(html) {
            var start = html.indexOf('<div id="RadEditor1"'), end = html.lastIndexOf('<script type="text/javascript">');
            return html.substring(start, end);
        },
        fixStyle: function() {
            if (!this.hadStyleFixed) {
                this.hadStyleFixed = true;
                var form = document.forms[0];
                if (!form) return;
                var intervalId1 = window.setInterval(function() {
                    if (!form.firstChild || !form.firstChild.className) return;
                    if (form.firstChild.className.indexOf('RadWindow RadWindow') != -1)
                        form.firstChild.style.zIndex = 9005;
                    window.clearInterval(intervalId1);
                }, 100);
                var intervalId2 = window.setInterval(function() {
                    if (!form.lastChild || !form.lastChild.className) return;
                    if (form.lastChild.className.indexOf('TelerikModalOverlay') != -1)
                        form.lastChild.style.zIndex = 9005;
                    window.clearInterval(intervalId2);
                }, 100);
            }
        },
        withRad: function(fn) {
            if (!this.rad) {
                this.on('radcreated', function() {
                    this.withRad(fn);
                }, this);
            }
            else if (this.rad._initialized) {
                fn.call(this);
            }
            else {
                var host = this;
                this.rad.add_load(function() {
                    fn.call(host);
                });
            }
        }
    });

    Ext.apply(Ext.ux.radEditor, {
        editors: [],
        add: function(instance) {
            Ext.ux.radEditor.editors.push(instance);
        },
        remove: function(instance) {
            var coll = Ext.ux.radEditor.editors;
            for (var i = 0; i < coll.length; i++) {
                if (instance.rad._uniqueID == instance.rad._uniqueID) {
                    coll.splice(i, 1);
                    break;
                }
            }
        },
        triggerSave: function() {
            var coll = Ext.ux.radEditor.editors;
            for (var i = 0; i < coll.length; i++)
                coll[i].saveToTextarea();
        }
    });

    //register
    Ext.ComponentMgr.registerType('radEditor', Ext.ux.radEditor);

    var CapacityHint = function(editor) {
        this.editor = editor;
        var host = this;
        this.editor.attachEventHandler('keydown', function(e) {
            host.onkeydown.call(host, e);
        });
        this.editor.attachEventHandler('mousedown', function(e) {
            host.mousedown.call(host, e);
        });
        this.cfg = {
            preventKeys: [38, 40, 13, 33, 34], //Up, Down, Enter, PageUp, PageDiwn
            hideKeys: [27, 37, 39, 9, 35, 36, 32], //ESC, Left, Right, Tab, End, Home, Space
            dataList: ['aaa', 'aaabbb', 'aaabbbccc']
        };
        this.initCon();
    };
    CapacityHint.prototype = {
        initCon: function() {
            this.con = document.createElement('div');
            this.con.id = 'hint_con';
            this.con.style.position = 'absolute';
            this.con.style.backgroundColor = '#E6E6FA';
            this.con.style.border = '2px solid #6d90b0';
            this.con.style.width = 250;
            this.con.style.zIndex = 9004;
            document.body.appendChild(this.con);
            this.iframePos = this.getPos(document.getElementById(this.editor._uniqueID + '_contentIframe'));
            //this.log = document.getElementById('log');
            this.hide();
        },
        hide: function() {
            this.isShow = false;
            this.mInputText = '';
            this.startRng = null;
            this.con.style.display = 'none';
        },
        hideValid: function(e) {
            var key = e.keyCode;
            if (this.isKeyIn(e, this.cfg.hideKeys))
                return true;
            if (this.isShow) {
                if (this.mInputText.length <= 1 && key == 8) //backspace
                    return true;
            }
            return false;
        },
        show: function(e) {
            if (this.isShow) return;
            this.isShow = true;
            this.startRng = this.getTarget(e).ownerDocument.selection.createRange();
            this.con.style.display = '';
            this.con.style.left = this.startRng.offsetLeft + this.iframePos.left;
            this.con.style.top = this.startRng.offsetTop + this.iframePos.top + 20;
        },
        query: function(ev) {
            var d = this.cfg.dataList, hasItem = false, host = this;
            if (d.length == 0)
                return;
            this.mInputText = this.mInputText.replace(new RegExp('(\\\\|\\\$|\\\^|\\\*|\\\(|\\\)|\\\+|\\\[|\\\{|\\\?|\\\|)', 'gim'), '\\$1');
            this.con.innerHTML = '';
            var re = new RegExp(this.mInputText, 'i');
            for (var i = 0; i < d.length; i++) {
                var t = d[i];
                if (re.test(t)) {
                    hasItem = true;
                    var divItem = document.createElement('div');
                    divItem.innerText = t;
                    this.addEventHandler(divItem, 'mouseover', function(e) {
                        host.getTarget(e).style.backgroundColor = '#6d90b0';
                    });
                    this.addEventHandler(divItem, 'mouseout', function(e) {
                        host.getTarget(e).style.backgroundColor = '';
                    });
                    this.addEventHandler(divItem, 'mouseup', function(e) {
                        //TODO:
                    });
                    this.addEventHandler(divItem, 'mousedown', function(e) {
                        host.hide();
                        var val = host.getTarget(e).innerText;
                        var rng = host.getTarget(ev).ownerDocument.selection.createRange();
                        rng.pasteHTML(val);
                        host.editor.setFocus();
                    });
                    this.con.appendChild(divItem);
                }
            }
            return hasItem;
        },
        onkeydown: function(e) {
            var f = function() {
                if (this.mInputText) {
                    if (this.query(e))
                        this.show(e);
                }
            }
            if (this.hideValid(e)) {
                this.hide();
                return;
            }
            else if (this.inputTextValid(e)) {
                this.mInputText += String.fromCharCode(e.keyCode);
                f.call(this);
            }
            else if (e.keyCode == 8) {
                if (this.mInputText.length > 0)
                    this.mInputText = this.mInputText.substr(0, this.mInputText.length - 1);
                f.call(this);
            }
            //this.log.innerHTML = this.mInputText + '<br/>keyCode:' + e.keyCode + '<br/>char:' + String.fromCharCode(e.keyCode);;
            if (this.isShow && this.isKeyIn(e, this.cfg.preventKeys))
                this.preventEvent(e);
        },
        mousedown: function(e) {
            this.hide();
        },
        isKeyIn: function(e, arr) {
            for (var i = 0; i < arr.length; i++) {
                if (arr[i] == e.keyCode)
                    return true;
            }
            return false;
        },
        inputTextValid: function(e) {
            var key = e.keyCode;
            if (key >= 65 && key <= 90) //A ~ Z
                return true;
            if ((key >= 48 && key <= 57) || (key >= 96 && key <= 107)) //0 ~ 9
                return true;
            return false;
        },
        preventEvent: function(e) {
            e.returnValue = false;
            if (e.preventDefault)
                e.preventDefault();
        },
        getPos: function(obj) {
            var pos = {};
            var t = obj.offsetTop;
            var l = obj.offsetLeft;
            while (obj = obj.offsetParent) {
                t += obj.offsetTop;
                l += obj.offsetLeft;
            }
            pos.top = t;
            pos.left = l;
            return pos;
        },
        getRngPos: function(rng) {
            this.editor.setFocus();
            //TODO:
        },
        getTarget: function(e) {
            return e.srcElement ? e.srcElement : e.target;
        },
        addEventHandler: function(target, type, handler) {
            if (target.addEventListener) {
                target.addEventListener(type, handler, false);
            } else if (target.attachEvent) {
                target.attachEvent('on' + type, handler);
            } else {
                target['on' + type] = handler;
            }
        }
    };
} ());